from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from typing import Union
from ..types import UNSET, Unset






T = TypeVar("T", bound="CreateExperienceInput")


@_attrs_define
class CreateExperienceInput:
    """ 
        Attributes:
            description (str):
            location (str):
            name (str):
            container_timeout_seconds (Union[Unset, int]):
     """

    description: str
    location: str
    name: str
    container_timeout_seconds: Union[Unset, int] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        description = self.description

        location = self.location

        name = self.name

        container_timeout_seconds = self.container_timeout_seconds


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
            "description": description,
            "location": location,
            "name": name,
        })
        if container_timeout_seconds is not UNSET:
            field_dict["containerTimeoutSeconds"] = container_timeout_seconds

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        description = d.pop("description")

        location = d.pop("location")

        name = d.pop("name")

        container_timeout_seconds = d.pop("containerTimeoutSeconds", UNSET)

        create_experience_input = cls(
            description=description,
            location=location,
            name=name,
            container_timeout_seconds=container_timeout_seconds,
        )


        create_experience_input.additional_properties = d
        return create_experience_input

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
