from typing import Any, Dict, Type, TypeVar, Tuple, Optional, BinaryIO, TextIO, TYPE_CHECKING

from typing import List


from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

from ..models.parameter_sweep_status import ParameterSweepStatus
from ..types import UNSET, Unset
from typing import Union
from dateutil.parser import isoparse
from typing import cast
import datetime






T = TypeVar("T", bound="ParameterSweepStatusHistoryType")


@_attrs_define
class ParameterSweepStatusHistoryType:
    """ 
        Attributes:
            status (Union[Unset, ParameterSweepStatus]):
            updated_at (Union[Unset, datetime.datetime]):
     """

    status: Union[Unset, ParameterSweepStatus] = UNSET
    updated_at: Union[Unset, datetime.datetime] = UNSET
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)


    def to_dict(self) -> Dict[str, Any]:
        status: Union[Unset, str] = UNSET
        if not isinstance(self.status, Unset):
            status = self.status.value


        updated_at: Union[Unset, str] = UNSET
        if not isinstance(self.updated_at, Unset):
            updated_at = self.updated_at.isoformat()


        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({
        })
        if status is not UNSET:
            field_dict["status"] = status
        if updated_at is not UNSET:
            field_dict["updatedAt"] = updated_at

        return field_dict



    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        _status = d.pop("status", UNSET)
        status: Union[Unset, ParameterSweepStatus]
        if isinstance(_status,  Unset):
            status = UNSET
        else:
            status = ParameterSweepStatus(_status)




        _updated_at = d.pop("updatedAt", UNSET)
        updated_at: Union[Unset, datetime.datetime]
        if isinstance(_updated_at,  Unset):
            updated_at = UNSET
        else:
            updated_at = isoparse(_updated_at)




        parameter_sweep_status_history_type = cls(
            status=status,
            updated_at=updated_at,
        )


        parameter_sweep_status_history_type.additional_properties = d
        return parameter_sweep_status_history_type

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
